unit schReferenciaGenericaClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID__ExisteFilaReferenciaGenerica = '{EBF53A68-5E57-4EAC-997E-C030A9D77BE9}';
  RID_InformeRefGenerica = '{8EAF0E0E-4FDA-4C79-9EB8-B881C24D98BA}';
  RID_GetProducto = '{D81DBABF-987E-4988-BA1F-34E8CC1A6EF0}';
  RID_ReferenciaGenerica = '{F940A3EC-CB4C-4F81-8207-BF0A31ED6C0D}';

  { Data table names }
  nme__ExisteFilaReferenciaGenerica = '_ExisteFilaReferenciaGenerica';
  nme_InformeRefGenerica = 'InformeRefGenerica';
  nme_GetProducto = 'GetProducto';
  nme_ReferenciaGenerica = 'ReferenciaGenerica';

  { _ExisteFilaReferenciaGenerica fields }
  fld__ExisteFilaReferenciaGenericaNUMINF = 'NUMINF';
  fld__ExisteFilaReferenciaGenericaCLAVE1 = 'CLAVE1';
  fld__ExisteFilaReferenciaGenericaCLAVE2 = 'CLAVE2';
  fld__ExisteFilaReferenciaGenericaCLAVE3 = 'CLAVE3';
  fld__ExisteFilaReferenciaGenericaNUMCON = 'NUMCON';

  { _ExisteFilaReferenciaGenerica field indexes }
  idx__ExisteFilaReferenciaGenericaNUMINF = 0;
  idx__ExisteFilaReferenciaGenericaCLAVE1 = 1;
  idx__ExisteFilaReferenciaGenericaCLAVE2 = 2;
  idx__ExisteFilaReferenciaGenericaCLAVE3 = 3;
  idx__ExisteFilaReferenciaGenericaNUMCON = 4;

  { InformeRefGenerica fields }
  fld_InformeRefGenericaCODCENTRO = 'CODCENTRO';
  fld_InformeRefGenericaCENTRO = 'CENTRO';
  fld_InformeRefGenericaCODVENDEDOR = 'CODVENDEDOR';
  fld_InformeRefGenericaVENDEDOR = 'VENDEDOR';
  fld_InformeRefGenericaFECHA = 'FECHA';
  fld_InformeRefGenericaNUMTALON = 'NUMTALON';
  fld_InformeRefGenericaCANTIDAD = 'CANTIDAD';
  fld_InformeRefGenericaVALTOT = 'VALTOT';

  { InformeRefGenerica field indexes }
  idx_InformeRefGenericaCODCENTRO = 0;
  idx_InformeRefGenericaCENTRO = 1;
  idx_InformeRefGenericaCODVENDEDOR = 2;
  idx_InformeRefGenericaVENDEDOR = 3;
  idx_InformeRefGenericaFECHA = 4;
  idx_InformeRefGenericaNUMTALON = 5;
  idx_InformeRefGenericaCANTIDAD = 6;
  idx_InformeRefGenericaVALTOT = 7;

  { GetProducto fields }
  fld_GetProductoCODIGO_BARRA = 'CODIGO_BARRA';
  fld_GetProductoCOR_PRODUTO = 'COR_PRODUTO';
  fld_GetProductoDESC_PRODUTO = 'DESC_PRODUTO';
  fld_GetProductoPRODUTO = 'PRODUTO';
  fld_GetProductoGRADE = 'GRADE';

  { GetProducto field indexes }
  idx_GetProductoCODIGO_BARRA = 0;
  idx_GetProductoCOR_PRODUTO = 1;
  idx_GetProductoDESC_PRODUTO = 2;
  idx_GetProductoPRODUTO = 3;
  idx_GetProductoGRADE = 4;

  { ReferenciaGenerica fields }
  fld_ReferenciaGenericaNUMINF = 'NUMINF';
  fld_ReferenciaGenericaCLAVE1 = 'CLAVE1';
  fld_ReferenciaGenericaCLAVE2 = 'CLAVE2';
  fld_ReferenciaGenericaCLAVE3 = 'CLAVE3';
  fld_ReferenciaGenericaNUMCON = 'NUMCON';
  fld_ReferenciaGenericaFECHA = 'FECHA';
  fld_ReferenciaGenericaCODCENTRO = 'CODCENTRO';
  fld_ReferenciaGenericaCENTRO = 'CENTRO';
  fld_ReferenciaGenericaCODVENDEDOR = 'CODVENDEDOR';
  fld_ReferenciaGenericaVENDEDOR = 'VENDEDOR';
  fld_ReferenciaGenericaNUMTALON = 'NUMTALON';
  fld_ReferenciaGenericaCODIGO_BARRA = 'CODIGO_BARRA';
  fld_ReferenciaGenericaCODIGO = 'CODIGO';
  fld_ReferenciaGenericaPRODUCTO = 'PRODUCTO';
  fld_ReferenciaGenericaCOLOR = 'COLOR';
  fld_ReferenciaGenericaTALLA = 'TALLA';
  fld_ReferenciaGenericaVTAPROCESO = 'VTAPROCESO';
  fld_ReferenciaGenericaVTAFINAL = 'VTAFINAL';
  fld_ReferenciaGenericaVTATERM = 'VTATERM';
  fld_ReferenciaGenericaVALTOT = 'VALTOT';
  fld_ReferenciaGenericaESTADO = 'ESTADO';
  fld_ReferenciaGenericaFECHACAMBIO = 'FECHACAMBIO';

  { ReferenciaGenerica field indexes }
  idx_ReferenciaGenericaNUMINF = 0;
  idx_ReferenciaGenericaCLAVE1 = 1;
  idx_ReferenciaGenericaCLAVE2 = 2;
  idx_ReferenciaGenericaCLAVE3 = 3;
  idx_ReferenciaGenericaNUMCON = 4;
  idx_ReferenciaGenericaFECHA = 5;
  idx_ReferenciaGenericaCODCENTRO = 6;
  idx_ReferenciaGenericaCENTRO = 7;
  idx_ReferenciaGenericaCODVENDEDOR = 8;
  idx_ReferenciaGenericaVENDEDOR = 9;
  idx_ReferenciaGenericaNUMTALON = 10;
  idx_ReferenciaGenericaCODIGO_BARRA = 11;
  idx_ReferenciaGenericaCODIGO = 12;
  idx_ReferenciaGenericaPRODUCTO = 13;
  idx_ReferenciaGenericaCOLOR = 14;
  idx_ReferenciaGenericaTALLA = 15;
  idx_ReferenciaGenericaVTAPROCESO = 16;
  idx_ReferenciaGenericaVTAFINAL = 17;
  idx_ReferenciaGenericaVTATERM = 18;
  idx_ReferenciaGenericaVALTOT = 19;
  idx_ReferenciaGenericaESTADO = 20;
  idx_ReferenciaGenericaFECHACAMBIO = 21;

type
  { I_ExisteFilaReferenciaGenerica }
  I_ExisteFilaReferenciaGenerica = interface(IDAStronglyTypedDataTable)
  ['{91F75EF4-A2FB-4C6C-9423-D193C95D7DF6}']
    { Property getters and setters }
    function GetNUMINFValue: String;
    procedure SetNUMINFValue(const aValue: String);
    function GetNUMINFIsNull: Boolean;
    procedure SetNUMINFIsNull(const aValue: Boolean);
    function GetCLAVE1Value: Float;
    procedure SetCLAVE1Value(const aValue: Float);
    function GetCLAVE1IsNull: Boolean;
    procedure SetCLAVE1IsNull(const aValue: Boolean);
    function GetCLAVE2Value: Integer;
    procedure SetCLAVE2Value(const aValue: Integer);
    function GetCLAVE2IsNull: Boolean;
    procedure SetCLAVE2IsNull(const aValue: Boolean);
    function GetCLAVE3Value: Integer;
    procedure SetCLAVE3Value(const aValue: Integer);
    function GetCLAVE3IsNull: Boolean;
    procedure SetCLAVE3IsNull(const aValue: Boolean);
    function GetNUMCONValue: Integer;
    procedure SetNUMCONValue(const aValue: Integer);
    function GetNUMCONIsNull: Boolean;
    procedure SetNUMCONIsNull(const aValue: Boolean);


    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull: Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull: Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull: Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull: Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;
    property NUMCONIsNull: Boolean read GetNUMCONIsNull write SetNUMCONIsNull;
  end;

  { T_ExisteFilaReferenciaGenericaDataTableRules }
  T_ExisteFilaReferenciaGenericaDataTableRules = class(TDADataTableRules, I_ExisteFilaReferenciaGenerica)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    function GetNUMINFIsNull: Boolean; virtual;
    procedure SetNUMINFIsNull(const aValue: Boolean); virtual;
    function GetCLAVE1Value: Float; virtual;
    procedure SetCLAVE1Value(const aValue: Float); virtual;
    function GetCLAVE1IsNull: Boolean; virtual;
    procedure SetCLAVE1IsNull(const aValue: Boolean); virtual;
    function GetCLAVE2Value: Integer; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    function GetCLAVE2IsNull: Boolean; virtual;
    procedure SetCLAVE2IsNull(const aValue: Boolean); virtual;
    function GetCLAVE3Value: Integer; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    function GetCLAVE3IsNull: Boolean; virtual;
    procedure SetCLAVE3IsNull(const aValue: Boolean); virtual;
    function GetNUMCONValue: Integer; virtual;
    procedure SetNUMCONValue(const aValue: Integer); virtual;
    function GetNUMCONIsNull: Boolean; virtual;
    procedure SetNUMCONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull: Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull: Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull: Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull: Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;
    property NUMCONIsNull: Boolean read GetNUMCONIsNull write SetNUMCONIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IInformeRefGenerica }
  IInformeRefGenerica = interface(IDAStronglyTypedDataTable)
  ['{0E01B29A-669B-45CC-9DDA-BC262E989813}']
    { Property getters and setters }
    function GetCODCENTROValue: String;
    procedure SetCODCENTROValue(const aValue: String);
    function GetCODCENTROIsNull: Boolean;
    procedure SetCODCENTROIsNull(const aValue: Boolean);
    function GetCENTROValue: String;
    procedure SetCENTROValue(const aValue: String);
    function GetCENTROIsNull: Boolean;
    procedure SetCENTROIsNull(const aValue: Boolean);
    function GetCODVENDEDORValue: String;
    procedure SetCODVENDEDORValue(const aValue: String);
    function GetCODVENDEDORIsNull: Boolean;
    procedure SetCODVENDEDORIsNull(const aValue: Boolean);
    function GetVENDEDORValue: String;
    procedure SetVENDEDORValue(const aValue: String);
    function GetVENDEDORIsNull: Boolean;
    procedure SetVENDEDORIsNull(const aValue: Boolean);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetFECHAIsNull: Boolean;
    procedure SetFECHAIsNull(const aValue: Boolean);
    function GetNUMTALONValue: String;
    procedure SetNUMTALONValue(const aValue: String);
    function GetNUMTALONIsNull: Boolean;
    procedure SetNUMTALONIsNull(const aValue: Boolean);
    function GetCANTIDADValue: String;
    procedure SetCANTIDADValue(const aValue: String);
    function GetCANTIDADIsNull: Boolean;
    procedure SetCANTIDADIsNull(const aValue: Boolean);
    function GetVALTOTValue: Float;
    procedure SetVALTOTValue(const aValue: Float);
    function GetVALTOTIsNull: Boolean;
    procedure SetVALTOTIsNull(const aValue: Boolean);


    { Properties }
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CODCENTROIsNull: Boolean read GetCODCENTROIsNull write SetCODCENTROIsNull;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull: Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property CODVENDEDORIsNull: Boolean read GetCODVENDEDORIsNull write SetCODVENDEDORIsNull;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull: Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull: Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property CANTIDAD: String read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull: Boolean read GetVALTOTIsNull write SetVALTOTIsNull;
  end;

  { TInformeRefGenericaDataTableRules }
  TInformeRefGenericaDataTableRules = class(TDADataTableRules, IInformeRefGenerica)
  private
  protected
    { Property getters and setters }
    function GetCODCENTROValue: String; virtual;
    procedure SetCODCENTROValue(const aValue: String); virtual;
    function GetCODCENTROIsNull: Boolean; virtual;
    procedure SetCODCENTROIsNull(const aValue: Boolean); virtual;
    function GetCENTROValue: String; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    function GetCENTROIsNull: Boolean; virtual;
    procedure SetCENTROIsNull(const aValue: Boolean); virtual;
    function GetCODVENDEDORValue: String; virtual;
    procedure SetCODVENDEDORValue(const aValue: String); virtual;
    function GetCODVENDEDORIsNull: Boolean; virtual;
    procedure SetCODVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetVENDEDORValue: String; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    function GetVENDEDORIsNull: Boolean; virtual;
    procedure SetVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetFECHAIsNull: Boolean; virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetNUMTALONValue: String; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    function GetNUMTALONIsNull: Boolean; virtual;
    procedure SetNUMTALONIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: String; virtual;
    procedure SetCANTIDADValue(const aValue: String); virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetVALTOTValue: Float; virtual;
    procedure SetVALTOTValue(const aValue: Float); virtual;
    function GetVALTOTIsNull: Boolean; virtual;
    procedure SetVALTOTIsNull(const aValue: Boolean); virtual;

    { Properties }
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CODCENTROIsNull: Boolean read GetCODCENTROIsNull write SetCODCENTROIsNull;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull: Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property CODVENDEDORIsNull: Boolean read GetCODVENDEDORIsNull write SetCODVENDEDORIsNull;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull: Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull: Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property CANTIDAD: String read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull: Boolean read GetVALTOTIsNull write SetVALTOTIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  {
  Datos de una prenda
  }
  { IGetProducto }
  IGetProducto = interface(IDAStronglyTypedDataTable)
  ['{59B0B7BE-94F9-4EB1-B5FA-3E5C8F4A151A}']
    { Property getters and setters }
    function GetCODIGO_BARRAValue: String;
    procedure SetCODIGO_BARRAValue(const aValue: String);
    function GetCODIGO_BARRAIsNull: Boolean;
    procedure SetCODIGO_BARRAIsNull(const aValue: Boolean);
    function GetCOR_PRODUTOValue: String;
    procedure SetCOR_PRODUTOValue(const aValue: String);
    function GetCOR_PRODUTOIsNull: Boolean;
    procedure SetCOR_PRODUTOIsNull(const aValue: Boolean);
    function GetDESC_PRODUTOValue: String;
    procedure SetDESC_PRODUTOValue(const aValue: String);
    function GetDESC_PRODUTOIsNull: Boolean;
    procedure SetDESC_PRODUTOIsNull(const aValue: Boolean);
    function GetPRODUTOValue: String;
    procedure SetPRODUTOValue(const aValue: String);
    function GetPRODUTOIsNull: Boolean;
    procedure SetPRODUTOIsNull(const aValue: Boolean);
    function GetGRADEValue: String;
    procedure SetGRADEValue(const aValue: String);
    function GetGRADEIsNull: Boolean;
    procedure SetGRADEIsNull(const aValue: Boolean);


    { Properties }
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO_BARRAIsNull: Boolean read GetCODIGO_BARRAIsNull write SetCODIGO_BARRAIsNull;
    property COR_PRODUTO: String read GetCOR_PRODUTOValue write SetCOR_PRODUTOValue;
    property COR_PRODUTOIsNull: Boolean read GetCOR_PRODUTOIsNull write SetCOR_PRODUTOIsNull;
    property DESC_PRODUTO: String read GetDESC_PRODUTOValue write SetDESC_PRODUTOValue;
    property DESC_PRODUTOIsNull: Boolean read GetDESC_PRODUTOIsNull write SetDESC_PRODUTOIsNull;
    property PRODUTO: String read GetPRODUTOValue write SetPRODUTOValue;
    property PRODUTOIsNull: Boolean read GetPRODUTOIsNull write SetPRODUTOIsNull;
    property GRADE: String read GetGRADEValue write SetGRADEValue;
    property GRADEIsNull: Boolean read GetGRADEIsNull write SetGRADEIsNull;
  end;

  { TGetProductoDataTableRules }
  TGetProductoDataTableRules = class(TDADataTableRules, IGetProducto)
  private
  protected
    { Property getters and setters }
    function GetCODIGO_BARRAValue: String; virtual;
    procedure SetCODIGO_BARRAValue(const aValue: String); virtual;
    function GetCODIGO_BARRAIsNull: Boolean; virtual;
    procedure SetCODIGO_BARRAIsNull(const aValue: Boolean); virtual;
    function GetCOR_PRODUTOValue: String; virtual;
    procedure SetCOR_PRODUTOValue(const aValue: String); virtual;
    function GetCOR_PRODUTOIsNull: Boolean; virtual;
    procedure SetCOR_PRODUTOIsNull(const aValue: Boolean); virtual;
    function GetDESC_PRODUTOValue: String; virtual;
    procedure SetDESC_PRODUTOValue(const aValue: String); virtual;
    function GetDESC_PRODUTOIsNull: Boolean; virtual;
    procedure SetDESC_PRODUTOIsNull(const aValue: Boolean); virtual;
    function GetPRODUTOValue: String; virtual;
    procedure SetPRODUTOValue(const aValue: String); virtual;
    function GetPRODUTOIsNull: Boolean; virtual;
    procedure SetPRODUTOIsNull(const aValue: Boolean); virtual;
    function GetGRADEValue: String; virtual;
    procedure SetGRADEValue(const aValue: String); virtual;
    function GetGRADEIsNull: Boolean; virtual;
    procedure SetGRADEIsNull(const aValue: Boolean); virtual;

    { Properties }
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO_BARRAIsNull: Boolean read GetCODIGO_BARRAIsNull write SetCODIGO_BARRAIsNull;
    property COR_PRODUTO: String read GetCOR_PRODUTOValue write SetCOR_PRODUTOValue;
    property COR_PRODUTOIsNull: Boolean read GetCOR_PRODUTOIsNull write SetCOR_PRODUTOIsNull;
    property DESC_PRODUTO: String read GetDESC_PRODUTOValue write SetDESC_PRODUTOValue;
    property DESC_PRODUTOIsNull: Boolean read GetDESC_PRODUTOIsNull write SetDESC_PRODUTOIsNull;
    property PRODUTO: String read GetPRODUTOValue write SetPRODUTOValue;
    property PRODUTOIsNull: Boolean read GetPRODUTOIsNull write SetPRODUTOIsNull;
    property GRADE: String read GetGRADEValue write SetGRADEValue;
    property GRADEIsNull: Boolean read GetGRADEIsNull write SetGRADEIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IReferenciaGenerica }
  IReferenciaGenerica = interface(IDAStronglyTypedDataTable)
  ['{BD898F5A-34C8-48CF-97F4-AC215575085C}']
    { Property getters and setters }
    function GetNUMINFValue: String;
    procedure SetNUMINFValue(const aValue: String);
    function GetNUMINFIsNull: Boolean;
    procedure SetNUMINFIsNull(const aValue: Boolean);
    function GetCLAVE1Value: Float;
    procedure SetCLAVE1Value(const aValue: Float);
    function GetCLAVE1IsNull: Boolean;
    procedure SetCLAVE1IsNull(const aValue: Boolean);
    function GetCLAVE2Value: Integer;
    procedure SetCLAVE2Value(const aValue: Integer);
    function GetCLAVE2IsNull: Boolean;
    procedure SetCLAVE2IsNull(const aValue: Boolean);
    function GetCLAVE3Value: Integer;
    procedure SetCLAVE3Value(const aValue: Integer);
    function GetCLAVE3IsNull: Boolean;
    procedure SetCLAVE3IsNull(const aValue: Boolean);
    function GetNUMCONValue: Integer;
    procedure SetNUMCONValue(const aValue: Integer);
    function GetNUMCONIsNull: Boolean;
    procedure SetNUMCONIsNull(const aValue: Boolean);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetFECHAIsNull: Boolean;
    procedure SetFECHAIsNull(const aValue: Boolean);
    function GetCODCENTROValue: String;
    procedure SetCODCENTROValue(const aValue: String);
    function GetCODCENTROIsNull: Boolean;
    procedure SetCODCENTROIsNull(const aValue: Boolean);
    function GetCENTROValue: String;
    procedure SetCENTROValue(const aValue: String);
    function GetCENTROIsNull: Boolean;
    procedure SetCENTROIsNull(const aValue: Boolean);
    function GetCODVENDEDORValue: String;
    procedure SetCODVENDEDORValue(const aValue: String);
    function GetCODVENDEDORIsNull: Boolean;
    procedure SetCODVENDEDORIsNull(const aValue: Boolean);
    function GetVENDEDORValue: String;
    procedure SetVENDEDORValue(const aValue: String);
    function GetVENDEDORIsNull: Boolean;
    procedure SetVENDEDORIsNull(const aValue: Boolean);
    function GetNUMTALONValue: String;
    procedure SetNUMTALONValue(const aValue: String);
    function GetNUMTALONIsNull: Boolean;
    procedure SetNUMTALONIsNull(const aValue: Boolean);
    function GetCODIGO_BARRAValue: String;
    procedure SetCODIGO_BARRAValue(const aValue: String);
    function GetCODIGO_BARRAIsNull: Boolean;
    procedure SetCODIGO_BARRAIsNull(const aValue: Boolean);
    function GetCODIGOValue: String;
    procedure SetCODIGOValue(const aValue: String);
    function GetCODIGOIsNull: Boolean;
    procedure SetCODIGOIsNull(const aValue: Boolean);
    function GetPRODUCTOValue: String;
    procedure SetPRODUCTOValue(const aValue: String);
    function GetPRODUCTOIsNull: Boolean;
    procedure SetPRODUCTOIsNull(const aValue: Boolean);
    function GetCOLORValue: String;
    procedure SetCOLORValue(const aValue: String);
    function GetCOLORIsNull: Boolean;
    procedure SetCOLORIsNull(const aValue: Boolean);
    function GetTALLAValue: String;
    procedure SetTALLAValue(const aValue: String);
    function GetTALLAIsNull: Boolean;
    procedure SetTALLAIsNull(const aValue: Boolean);
    function GetVTAPROCESOValue: Float;
    procedure SetVTAPROCESOValue(const aValue: Float);
    function GetVTAPROCESOIsNull: Boolean;
    procedure SetVTAPROCESOIsNull(const aValue: Boolean);
    function GetVTAFINALValue: Float;
    procedure SetVTAFINALValue(const aValue: Float);
    function GetVTAFINALIsNull: Boolean;
    procedure SetVTAFINALIsNull(const aValue: Boolean);
    function GetVTATERMValue: Float;
    procedure SetVTATERMValue(const aValue: Float);
    function GetVTATERMIsNull: Boolean;
    procedure SetVTATERMIsNull(const aValue: Boolean);
    function GetVALTOTValue: Float;
    procedure SetVALTOTValue(const aValue: Float);
    function GetVALTOTIsNull: Boolean;
    procedure SetVALTOTIsNull(const aValue: Boolean);
    function GetESTADOValue: String;
    procedure SetESTADOValue(const aValue: String);
    function GetESTADOIsNull: Boolean;
    procedure SetESTADOIsNull(const aValue: Boolean);
    function GetFECHACAMBIOValue: DateTime;
    procedure SetFECHACAMBIOValue(const aValue: DateTime);
    function GetFECHACAMBIOIsNull: Boolean;
    procedure SetFECHACAMBIOIsNull(const aValue: Boolean);


    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull: Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull: Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull: Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull: Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;
    property NUMCONIsNull: Boolean read GetNUMCONIsNull write SetNUMCONIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CODCENTROIsNull: Boolean read GetCODCENTROIsNull write SetCODCENTROIsNull;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull: Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property CODVENDEDORIsNull: Boolean read GetCODVENDEDORIsNull write SetCODVENDEDORIsNull;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull: Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull: Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO_BARRAIsNull: Boolean read GetCODIGO_BARRAIsNull write SetCODIGO_BARRAIsNull;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property CODIGOIsNull: Boolean read GetCODIGOIsNull write SetCODIGOIsNull;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property PRODUCTOIsNull: Boolean read GetPRODUCTOIsNull write SetPRODUCTOIsNull;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property COLORIsNull: Boolean read GetCOLORIsNull write SetCOLORIsNull;
    property TALLA: String read GetTALLAValue write SetTALLAValue;
    property TALLAIsNull: Boolean read GetTALLAIsNull write SetTALLAIsNull;
    property VTAPROCESO: Float read GetVTAPROCESOValue write SetVTAPROCESOValue;
    property VTAPROCESOIsNull: Boolean read GetVTAPROCESOIsNull write SetVTAPROCESOIsNull;
    property VTAFINAL: Float read GetVTAFINALValue write SetVTAFINALValue;
    property VTAFINALIsNull: Boolean read GetVTAFINALIsNull write SetVTAFINALIsNull;
    property VTATERM: Float read GetVTATERMValue write SetVTATERMValue;
    property VTATERMIsNull: Boolean read GetVTATERMIsNull write SetVTATERMIsNull;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull: Boolean read GetVALTOTIsNull write SetVALTOTIsNull;
    property ESTADO: String read GetESTADOValue write SetESTADOValue;
    property ESTADOIsNull: Boolean read GetESTADOIsNull write SetESTADOIsNull;
    property FECHACAMBIO: DateTime read GetFECHACAMBIOValue write SetFECHACAMBIOValue;
    property FECHACAMBIOIsNull: Boolean read GetFECHACAMBIOIsNull write SetFECHACAMBIOIsNull;
  end;

  { TReferenciaGenericaDataTableRules }
  TReferenciaGenericaDataTableRules = class(TDADataTableRules, IReferenciaGenerica)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    function GetNUMINFIsNull: Boolean; virtual;
    procedure SetNUMINFIsNull(const aValue: Boolean); virtual;
    function GetCLAVE1Value: Float; virtual;
    procedure SetCLAVE1Value(const aValue: Float); virtual;
    function GetCLAVE1IsNull: Boolean; virtual;
    procedure SetCLAVE1IsNull(const aValue: Boolean); virtual;
    function GetCLAVE2Value: Integer; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    function GetCLAVE2IsNull: Boolean; virtual;
    procedure SetCLAVE2IsNull(const aValue: Boolean); virtual;
    function GetCLAVE3Value: Integer; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    function GetCLAVE3IsNull: Boolean; virtual;
    procedure SetCLAVE3IsNull(const aValue: Boolean); virtual;
    function GetNUMCONValue: Integer; virtual;
    procedure SetNUMCONValue(const aValue: Integer); virtual;
    function GetNUMCONIsNull: Boolean; virtual;
    procedure SetNUMCONIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetFECHAIsNull: Boolean; virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetCODCENTROValue: String; virtual;
    procedure SetCODCENTROValue(const aValue: String); virtual;
    function GetCODCENTROIsNull: Boolean; virtual;
    procedure SetCODCENTROIsNull(const aValue: Boolean); virtual;
    function GetCENTROValue: String; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    function GetCENTROIsNull: Boolean; virtual;
    procedure SetCENTROIsNull(const aValue: Boolean); virtual;
    function GetCODVENDEDORValue: String; virtual;
    procedure SetCODVENDEDORValue(const aValue: String); virtual;
    function GetCODVENDEDORIsNull: Boolean; virtual;
    procedure SetCODVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetVENDEDORValue: String; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    function GetVENDEDORIsNull: Boolean; virtual;
    procedure SetVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetNUMTALONValue: String; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    function GetNUMTALONIsNull: Boolean; virtual;
    procedure SetNUMTALONIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_BARRAValue: String; virtual;
    procedure SetCODIGO_BARRAValue(const aValue: String); virtual;
    function GetCODIGO_BARRAIsNull: Boolean; virtual;
    procedure SetCODIGO_BARRAIsNull(const aValue: Boolean); virtual;
    function GetCODIGOValue: String; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    function GetCODIGOIsNull: Boolean; virtual;
    procedure SetCODIGOIsNull(const aValue: Boolean); virtual;
    function GetPRODUCTOValue: String; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    function GetPRODUCTOIsNull: Boolean; virtual;
    procedure SetPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetCOLORValue: String; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    function GetCOLORIsNull: Boolean; virtual;
    procedure SetCOLORIsNull(const aValue: Boolean); virtual;
    function GetTALLAValue: String; virtual;
    procedure SetTALLAValue(const aValue: String); virtual;
    function GetTALLAIsNull: Boolean; virtual;
    procedure SetTALLAIsNull(const aValue: Boolean); virtual;
    function GetVTAPROCESOValue: Float; virtual;
    procedure SetVTAPROCESOValue(const aValue: Float); virtual;
    function GetVTAPROCESOIsNull: Boolean; virtual;
    procedure SetVTAPROCESOIsNull(const aValue: Boolean); virtual;
    function GetVTAFINALValue: Float; virtual;
    procedure SetVTAFINALValue(const aValue: Float); virtual;
    function GetVTAFINALIsNull: Boolean; virtual;
    procedure SetVTAFINALIsNull(const aValue: Boolean); virtual;
    function GetVTATERMValue: Float; virtual;
    procedure SetVTATERMValue(const aValue: Float); virtual;
    function GetVTATERMIsNull: Boolean; virtual;
    procedure SetVTATERMIsNull(const aValue: Boolean); virtual;
    function GetVALTOTValue: Float; virtual;
    procedure SetVALTOTValue(const aValue: Float); virtual;
    function GetVALTOTIsNull: Boolean; virtual;
    procedure SetVALTOTIsNull(const aValue: Boolean); virtual;
    function GetESTADOValue: String; virtual;
    procedure SetESTADOValue(const aValue: String); virtual;
    function GetESTADOIsNull: Boolean; virtual;
    procedure SetESTADOIsNull(const aValue: Boolean); virtual;
    function GetFECHACAMBIOValue: DateTime; virtual;
    procedure SetFECHACAMBIOValue(const aValue: DateTime); virtual;
    function GetFECHACAMBIOIsNull: Boolean; virtual;
    procedure SetFECHACAMBIOIsNull(const aValue: Boolean); virtual;

    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull: Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull: Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull: Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull: Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;
    property NUMCONIsNull: Boolean read GetNUMCONIsNull write SetNUMCONIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CODCENTROIsNull: Boolean read GetCODCENTROIsNull write SetCODCENTROIsNull;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull: Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property CODVENDEDORIsNull: Boolean read GetCODVENDEDORIsNull write SetCODVENDEDORIsNull;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull: Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull: Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO_BARRAIsNull: Boolean read GetCODIGO_BARRAIsNull write SetCODIGO_BARRAIsNull;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property CODIGOIsNull: Boolean read GetCODIGOIsNull write SetCODIGOIsNull;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property PRODUCTOIsNull: Boolean read GetPRODUCTOIsNull write SetPRODUCTOIsNull;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property COLORIsNull: Boolean read GetCOLORIsNull write SetCOLORIsNull;
    property TALLA: String read GetTALLAValue write SetTALLAValue;
    property TALLAIsNull: Boolean read GetTALLAIsNull write SetTALLAIsNull;
    property VTAPROCESO: Float read GetVTAPROCESOValue write SetVTAPROCESOValue;
    property VTAPROCESOIsNull: Boolean read GetVTAPROCESOIsNull write SetVTAPROCESOIsNull;
    property VTAFINAL: Float read GetVTAFINALValue write SetVTAFINALValue;
    property VTAFINALIsNull: Boolean read GetVTAFINALIsNull write SetVTAFINALIsNull;
    property VTATERM: Float read GetVTATERMValue write SetVTATERMValue;
    property VTATERMIsNull: Boolean read GetVTATERMIsNull write SetVTATERMIsNull;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull: Boolean read GetVALTOTIsNull write SetVALTOTIsNull;
    property ESTADO: String read GetESTADOValue write SetESTADOValue;
    property ESTADOIsNull: Boolean read GetESTADOIsNull write SetESTADOIsNull;
    property FECHACAMBIO: DateTime read GetFECHACAMBIOValue write SetFECHACAMBIOValue;
    property FECHACAMBIOIsNull: Boolean read GetFECHACAMBIOIsNull write SetFECHACAMBIOIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ T_ExisteFilaReferenciaGenericaDataTableRules }
constructor T_ExisteFilaReferenciaGenericaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor T_ExisteFilaReferenciaGenericaDataTableRules.Destroy;
begin
  inherited;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetNUMINFValue: String;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMINF].AsString;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetNUMINFValue(const aValue: String);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMINF].AsString := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetNUMINFIsNull: boolean;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMINF].IsNull;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetNUMINFIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMINF].AsVariant := Null;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE1Value: Float;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE1].AsFloat;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE1Value(const aValue: Float);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE1].AsFloat := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE1IsNull: boolean;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE1].IsNull;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE1IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE1].AsVariant := Null;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE2Value: Integer;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE2].AsInteger;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE2Value(const aValue: Integer);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE2].AsInteger := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE2IsNull: boolean;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE2].IsNull;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE2IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE2].AsVariant := Null;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE3Value: Integer;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE3].AsInteger;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE3Value(const aValue: Integer);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE3].AsInteger := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE3IsNull: boolean;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE3].IsNull;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE3IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE3].AsVariant := Null;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetNUMCONValue: Integer;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMCON].AsInteger;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetNUMCONValue(const aValue: Integer);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMCON].AsInteger := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetNUMCONIsNull: boolean;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMCON].IsNull;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetNUMCONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMCON].AsVariant := Null;
end;


{ TInformeRefGenericaDataTableRules }
constructor TInformeRefGenericaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TInformeRefGenericaDataTableRules.Destroy;
begin
  inherited;
end;

function TInformeRefGenericaDataTableRules.GetCODCENTROValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCODCENTRO].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCODCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCODCENTRO].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetCODCENTROIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCODCENTRO].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetCODCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaCODCENTRO].AsVariant := Null;
end;

function TInformeRefGenericaDataTableRules.GetCENTROValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCENTRO].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCENTRO].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetCENTROIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCENTRO].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaCENTRO].AsVariant := Null;
end;

function TInformeRefGenericaDataTableRules.GetCODVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCODVENDEDOR].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCODVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCODVENDEDOR].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetCODVENDEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCODVENDEDOR].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetCODVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaCODVENDEDOR].AsVariant := Null;
end;

function TInformeRefGenericaDataTableRules.GetVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaVENDEDOR].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaVENDEDOR].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetVENDEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaVENDEDOR].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaVENDEDOR].AsVariant := Null;
end;

function TInformeRefGenericaDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_InformeRefGenericaFECHA].AsDateTime;
end;

procedure TInformeRefGenericaDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_InformeRefGenericaFECHA].AsDateTime := aValue;
end;

function TInformeRefGenericaDataTableRules.GetFECHAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaFECHA].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaFECHA].AsVariant := Null;
end;

function TInformeRefGenericaDataTableRules.GetNUMTALONValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaNUMTALON].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetNUMTALONValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaNUMTALON].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetNUMTALONIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaNUMTALON].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetNUMTALONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaNUMTALON].AsVariant := Null;
end;

function TInformeRefGenericaDataTableRules.GetCANTIDADValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCANTIDAD].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCANTIDADValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCANTIDAD].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetCANTIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCANTIDAD].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaCANTIDAD].AsVariant := Null;
end;

function TInformeRefGenericaDataTableRules.GetVALTOTValue: Float;
begin
  result := DataTable.Fields[idx_InformeRefGenericaVALTOT].AsFloat;
end;

procedure TInformeRefGenericaDataTableRules.SetVALTOTValue(const aValue: Float);
begin
  DataTable.Fields[idx_InformeRefGenericaVALTOT].AsFloat := aValue;
end;

function TInformeRefGenericaDataTableRules.GetVALTOTIsNull: boolean;
begin
  result := DataTable.Fields[idx_InformeRefGenericaVALTOT].IsNull;
end;

procedure TInformeRefGenericaDataTableRules.SetVALTOTIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InformeRefGenericaVALTOT].AsVariant := Null;
end;


{ TGetProductoDataTableRules }
constructor TGetProductoDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TGetProductoDataTableRules.Destroy;
begin
  inherited;
end;

function TGetProductoDataTableRules.GetCODIGO_BARRAValue: String;
begin
  result := DataTable.Fields[idx_GetProductoCODIGO_BARRA].AsString;
end;

procedure TGetProductoDataTableRules.SetCODIGO_BARRAValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoCODIGO_BARRA].AsString := aValue;
end;

function TGetProductoDataTableRules.GetCODIGO_BARRAIsNull: boolean;
begin
  result := DataTable.Fields[idx_GetProductoCODIGO_BARRA].IsNull;
end;

procedure TGetProductoDataTableRules.SetCODIGO_BARRAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_GetProductoCODIGO_BARRA].AsVariant := Null;
end;

function TGetProductoDataTableRules.GetCOR_PRODUTOValue: String;
begin
  result := DataTable.Fields[idx_GetProductoCOR_PRODUTO].AsString;
end;

procedure TGetProductoDataTableRules.SetCOR_PRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoCOR_PRODUTO].AsString := aValue;
end;

function TGetProductoDataTableRules.GetCOR_PRODUTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_GetProductoCOR_PRODUTO].IsNull;
end;

procedure TGetProductoDataTableRules.SetCOR_PRODUTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_GetProductoCOR_PRODUTO].AsVariant := Null;
end;

function TGetProductoDataTableRules.GetDESC_PRODUTOValue: String;
begin
  result := DataTable.Fields[idx_GetProductoDESC_PRODUTO].AsString;
end;

procedure TGetProductoDataTableRules.SetDESC_PRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoDESC_PRODUTO].AsString := aValue;
end;

function TGetProductoDataTableRules.GetDESC_PRODUTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_GetProductoDESC_PRODUTO].IsNull;
end;

procedure TGetProductoDataTableRules.SetDESC_PRODUTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_GetProductoDESC_PRODUTO].AsVariant := Null;
end;

function TGetProductoDataTableRules.GetPRODUTOValue: String;
begin
  result := DataTable.Fields[idx_GetProductoPRODUTO].AsString;
end;

procedure TGetProductoDataTableRules.SetPRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoPRODUTO].AsString := aValue;
end;

function TGetProductoDataTableRules.GetPRODUTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_GetProductoPRODUTO].IsNull;
end;

procedure TGetProductoDataTableRules.SetPRODUTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_GetProductoPRODUTO].AsVariant := Null;
end;

function TGetProductoDataTableRules.GetGRADEValue: String;
begin
  result := DataTable.Fields[idx_GetProductoGRADE].AsString;
end;

procedure TGetProductoDataTableRules.SetGRADEValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoGRADE].AsString := aValue;
end;

function TGetProductoDataTableRules.GetGRADEIsNull: boolean;
begin
  result := DataTable.Fields[idx_GetProductoGRADE].IsNull;
end;

procedure TGetProductoDataTableRules.SetGRADEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_GetProductoGRADE].AsVariant := Null;
end;


{ TReferenciaGenericaDataTableRules }
constructor TReferenciaGenericaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TReferenciaGenericaDataTableRules.Destroy;
begin
  inherited;
end;

function TReferenciaGenericaDataTableRules.GetNUMINFValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMINF].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMINFValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaNUMINF].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetNUMINFIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMINF].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMINFIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaNUMINF].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE1Value: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE1].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE1Value(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaCLAVE1].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE1IsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE1].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE1IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCLAVE1].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE2Value: Integer;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE2].AsInteger;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE2Value(const aValue: Integer);
begin
  DataTable.Fields[idx_ReferenciaGenericaCLAVE2].AsInteger := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE2IsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE2].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE2IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCLAVE2].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE3Value: Integer;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE3].AsInteger;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE3Value(const aValue: Integer);
begin
  DataTable.Fields[idx_ReferenciaGenericaCLAVE3].AsInteger := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE3IsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE3].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE3IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCLAVE3].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetNUMCONValue: Integer;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMCON].AsInteger;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMCONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ReferenciaGenericaNUMCON].AsInteger := aValue;
end;

function TReferenciaGenericaDataTableRules.GetNUMCONIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMCON].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMCONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaNUMCON].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaFECHA].AsDateTime;
end;

procedure TReferenciaGenericaDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ReferenciaGenericaFECHA].AsDateTime := aValue;
end;

function TReferenciaGenericaDataTableRules.GetFECHAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaFECHA].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaFECHA].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCODCENTROValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODCENTRO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODCENTRO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODCENTROIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODCENTRO].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCODCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCODCENTRO].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCENTROValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCENTRO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCENTRO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCENTROIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCENTRO].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCENTRO].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCODVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODVENDEDOR].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODVENDEDOR].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODVENDEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODVENDEDOR].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCODVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCODVENDEDOR].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVENDEDOR].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaVENDEDOR].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVENDEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVENDEDOR].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaVENDEDOR].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetNUMTALONValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMTALON].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMTALONValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaNUMTALON].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetNUMTALONIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMTALON].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMTALONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaNUMTALON].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCODIGO_BARRAValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODIGO_BARRA].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODIGO_BARRAValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODIGO_BARRA].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODIGO_BARRAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODIGO_BARRA].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCODIGO_BARRAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCODIGO_BARRA].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCODIGOValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODIGO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODIGOValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODIGO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODIGOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODIGO].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCODIGOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCODIGO].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaPRODUCTO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaPRODUCTO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetPRODUCTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaPRODUCTO].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaPRODUCTO].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetCOLORValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCOLOR].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCOLORValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCOLOR].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCOLORIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCOLOR].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetCOLORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaCOLOR].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetTALLAValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaTALLA].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetTALLAValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaTALLA].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetTALLAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaTALLA].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetTALLAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaTALLA].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetVTAPROCESOValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTAPROCESO].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVTAPROCESOValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVTAPROCESO].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVTAPROCESOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTAPROCESO].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetVTAPROCESOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaVTAPROCESO].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetVTAFINALValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTAFINAL].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVTAFINALValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVTAFINAL].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVTAFINALIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTAFINAL].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetVTAFINALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaVTAFINAL].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetVTATERMValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTATERM].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVTATERMValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVTATERM].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVTATERMIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTATERM].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetVTATERMIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaVTATERM].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetVALTOTValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVALTOT].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVALTOTValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVALTOT].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVALTOTIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVALTOT].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetVALTOTIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaVALTOT].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetESTADOValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaESTADO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetESTADOValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaESTADO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetESTADOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaESTADO].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetESTADOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaESTADO].AsVariant := Null;
end;

function TReferenciaGenericaDataTableRules.GetFECHACAMBIOValue: DateTime;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaFECHACAMBIO].AsDateTime;
end;

procedure TReferenciaGenericaDataTableRules.SetFECHACAMBIOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ReferenciaGenericaFECHACAMBIO].AsDateTime := aValue;
end;

function TReferenciaGenericaDataTableRules.GetFECHACAMBIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaFECHACAMBIO].IsNull;
end;

procedure TReferenciaGenericaDataTableRules.SetFECHACAMBIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ReferenciaGenericaFECHACAMBIO].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID__ExisteFilaReferenciaGenerica, T_ExisteFilaReferenciaGenericaDataTableRules);
  RegisterDataTableRules(RID_InformeRefGenerica, TInformeRefGenericaDataTableRules);
  RegisterDataTableRules(RID_GetProducto, TGetProductoDataTableRules);
  RegisterDataTableRules(RID_ReferenciaGenerica, TReferenciaGenericaDataTableRules);

end.
